package vo

import "gitea.cdlsxd.cn/sdk/plugin/proto"

type Status string

const (
	QueryStatusPending = "DEALING"
	QueryStatusSuccess = "SUCCESS"
	QueryStatusFailed  = "FAIL"
	QueryStatusRefund  = "REFUND"
)

var queryStatusTextMap = map[Status]string{
	QueryStatusPending: "处理中",
	QueryStatusSuccess: "转账成功",
	QueryStatusFailed:  "失败",
	QueryStatusRefund:  "退票",
}

var queryStatusMap = map[Status]proto.Status{
	QueryStatusPending: proto.Status_ING,
	QueryStatusSuccess: proto.Status_SUCCESS,
	QueryStatusFailed:  proto.Status_FAIL,
	QueryStatusRefund:  proto.Status_FAIL,
}

func (o Status) GetText() string {
	msg, ok := queryStatusTextMap[o]
	if !ok {
		return ""
	}
	return msg
}

func (o Status) GetOrderStatus() proto.Status {
	if o == "" {
		return proto.Status_INVALID
	}
	if resultStatus, ok := queryStatusMap[o]; ok {
		return resultStatus
	}
	return proto.Status_FAIL
}
